#include <string.h>
#include <time.h>
#include "inagent.h"

Listener::Listener(int fd)
{
    proto = UNKNOWN;
    if (fd >= 0) {
        conn = new DPF_channel(fd);
    } else {
        conn = NULL;
    }
    status = REGISTERING_1;
    entered = time(NULL);
    myaddr = NULL;
    opened = false;
    listening = false;
    error = 0;
    missed = 0;
    pre = next = NULL;
}

Listener::~Listener()
{
    if (conn) { delete conn; }
    if (myaddr) { delete myaddr; }
}

void
Listener::tostr(const char *prefix, char *str)
{
    sprintf(str, "%slistener=", prefix);
    if (conn) {
        conn->tostr(NULL, &str[strlen(str)]);
    } else {
        sprintf(&str[strlen(str)], "conn=NULL ");
    }
    if (proto == TCP) {
        sprintf(&str[strlen(str)], "TCP ");
    } else if (proto == UDP) {
        sprintf(&str[strlen(str)], "UDP ");
    } else {
        sprintf(&str[strlen(str)], "UNKNOWN ");
    }
    if (myaddr) {
        myaddr->tostr(NULL, &str[strlen(str)]);
    } else {
        sprintf(&str[strlen(str)], "myaddr=NULL ");
    }
    if (listening) {
        sprintf(&str[strlen(str)], "listening ");
    }
    sprintf(&str[strlen(str)], "missed=%d", missed);
}
