#ifndef FW_RULE_H
#define FW_RULE_H

#include <netinet/in.h>

/* req. code */
#define ADD "add"
#define DELETE "delete"
#define QUERY "query"

/* command codes */
#define CMD_ADD 1
#define CMD_DEL 2

/* response code */
#define NAK "nak"
#define ADDED "added"
#define DELETED "deleted"
#define RESULT "result"

/* error codes */
#define SUCCESS 0
#define INVALID_CMD 1
#define INVALID_PROTO 2
#define INVALID_PORT 3
#define NO_MORE_FREE_PORT 4
#define ALREADY_SET 5
#define RULE_REUSED 6
#define LOCAL_NOAVAIL 7
#define COLFLICT_RULE 8
#define RULE_NOT_FOUND 9
#define INTERNAL_ERR 19

struct fwRule {
    char target;
    uint32_t priv_ip;
    uint16_t priv_port;
    uint32_t local_ip;
    uint16_t local_port;
    uint32_t rmt_ip;
    uint16_t rmt_port;
    struct fwRule *pre;
	struct fwRule *next;
};

#endif
