#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>

#include "DPF.h"

// run as "tcp_client_1 server_ip port"
int
main(int argc, char *argv[])
{
    if (argc != 3) {
        printf("usage: tcp_client_1 server_ip port\n");
        return -1;
    }

    int fd = DPF_socket(AF_INET, SOCK_STREAM, 0);
    if (fd < 0) {
        printf("DPF_socket failed: %s\n", strerror(errno));
        return -1;
    }

    struct sockaddr_in peer;
    peer.sin_family = AF_INET;
    if (inet_aton(argv[1], &peer.sin_addr) < 0) {
        printf("ip address is in invalid form: %s\n", strerror(errno));
        return -1;
    }
    short port = atoi(argv[2]);
    peer.sin_port = htons(port);
    socklen_t addrlen = sizeof(struct sockaddr_in);
    if (DPF_connect(fd, (struct sockaddr *)&peer, addrlen) < 0) {
        printf("DPF_connect: failed - %s\n", strerror(errno));
        return -1;
    }

    while(1) {
        printf("***type string send: ");
        char sbuf[500];
        (void) gets(sbuf);
        if (sbuf[0] == '!') {
            DPF_close(fd);
            return 0;
        }
        int sent = DPF_send(fd, sbuf, strlen(sbuf)+1, 0);
        printf("***%d bytes sent\n", sent);
        int total = 0, rcved = 0;
        char rbuf[500];
        while(total < sent) {
            rcved = DPF_recv(fd, rbuf, sent - total, 0);
            if (rcved < 0) {
                printf("DPF_recv failed: %s\n", strerror(errno));
                DPF_close(fd);
                return -1;
            } else if (rcved == 0) {
                printf("server closed\n");
                DPF_close(fd);
                return 0;
            }
            total += rcved;
        }
        printf("%d bytes received: %s\n", total, rbuf);
        for (int i=0; i<total; i++) {
            if (sbuf[i] != rbuf[i]) {
                printf("compare failed\n");
                DPF_close(fd);
                return -1;
            }
        }
    }
}
