#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

#include "internet.h"
#include "DPF.h"

int
main(int argc, char *argv[])
{
    int fd = atoi(argv[1]);
    int newfd = atoi(argv[2]);
    printf("echo_server: listen_sock(%d) accepted_sock(%d): %d\n", fd, newfd);

    DPF_close(fd);

    int bytes;
    int total, sent;
    char buf[10000];

    while(true) {
        bytes = DPF_recv(newfd, buf, 10000, 0);
        if (bytes < 0) {
            printf("DPF_recv failed: %s\n", strerror(errno));
            return -1;
        } else if (bytes == 0) {
            printf("client closed\n");
            return 0;
        }
        printf("\t%d bytes received\n", bytes);
        total = sent = 0;
        while(total < bytes) {
            sent = DPF_send(newfd, &buf[total], bytes - total, 0);
            if (sent < 0) {
                printf("DPF_send failed: %s\n", strerror(errno));
                return -1;
            }
            total += sent;
        }
        printf("\techoed\n");
    }
    return 0;
}
