#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "DPF.h"

// run as "udp_client_1 server_ip port"
int
main(int argc, char *argv[])
{
    if (argc != 3) {
        printf("usage: udp_client_1 server_ip port\n");
        return -1;
    }

    int fd = DPF_socket(AF_INET, SOCK_DGRAM, 0);
    if (fd < 0) {
        printf("DPF_socket failed: %s\n", strerror(errno));
        return -1;
    }

    struct sockaddr_in peer;
    peer.sin_family = AF_INET;
    if (inet_aton(argv[1], &peer.sin_addr) < 0) {
        printf("ip address is in invalid form: %s\n", strerror(errno));
        return -1;
    }
    short port = atoi(argv[2]);
    peer.sin_port = htons(port);
    socklen_t addrlen = sizeof(struct sockaddr_in);

    while(1) {
        printf("***type string send: ");
        char sbuf[1000];
        (void) gets(sbuf);
        if (sbuf[0] == '!') {
            DPF_close(fd);
            return 0;
        }
        int sent = DPF_sendto(fd, sbuf, strlen(sbuf)+1, 0,
                (struct sockaddr *)&peer, addrlen);
        printf("***%d bytes sent\n", sent);
        char rbuf[500];
        struct sockaddr_in from;
        socklen_t fromlen = sizeof(struct sockaddr_in);
        int rcved = DPF_recvfrom(fd, rbuf, sent, 0,
                (struct sockaddr *)&from, &fromlen);
        if (rcved < 0) {
            printf("DPF_recvfrom failed: %s\n", strerror(errno));
            return -1;
        }
        for (int i=0; i<rcved; i++) {
            if (sbuf[i] != rbuf[i]) {
                printf("compare failed\n");
                return -1;
            }
        }
    }
}
