#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "DPF.h"

// run as "udp_client_2 server_ip port"
int
main(int argc, char *argv[])
{
    int fd;
    char sbuf[1000], rbuf[1000];
    int sent, total, rcved;
    int i;
    unsigned short port;
    int ready;
    fd_set rdfds, wrfds;
    int error;

    if (argc != 3) {
        printf("usage: udp_client_2 server_ip port\n");
        return -1;
    }

    // create a socket
    fd = DPF_socket(AF_INET, SOCK_DGRAM, 0);
    if (fd < 0) {
        printf("DPF_socket failed: %s\n", strerror(errno));
        return -1;
    }
    printf("socket(fd=%d) created\n", fd);
    
    // bind the socket
    struct sockaddr_in myaddr;
    myaddr.sin_family = AF_INET;
    myaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    myaddr.sin_port = htons(0);
    if (DPF_bind(fd, (struct sockaddr *)&myaddr, sizeof(myaddr)) < 0) {
        printf("DPF_bind failed: %s\n", strerror(errno));
        return -1;
    }
    
    // connect the socket to the server
    struct sockaddr_in peer;
    peer.sin_family = AF_INET;
    if (inet_aton(argv[1], &peer.sin_addr) < 0) {
        printf("ip address is in invalid form: %s\n", strerror(errno));
        return -1;
    }
    port = atoi(argv[2]);
    peer.sin_port = htons(port);
    socklen_t addrlen = sizeof(struct sockaddr_in);
    if (DPF_connect(fd, (struct sockaddr *)&peer, addrlen) < 0) {
        printf("DPF_connect: failed - %s\n", strerror(errno));
        return -1;
    }
    printf("Successfully connected\n");

    while(1) {
        printf("***type string send: ");
        (void) gets(sbuf);
        if (sbuf[0] == '!') {
            DPF_close(fd);
            return 0;
        }
        sent = DPF_send(fd, sbuf, strlen(sbuf)+1, 0);
        printf("***%d bytes sent\n", sent);
        FD_ZERO(&rdfds);
        FD_SET(fd, &rdfds);
        ready = DPF_select(fd+1, &rdfds, NULL, NULL, NULL);
        if (ready < 0) {
            if (errno == EINTR) {continue;}
            printf("select failed: %s\n", strerror(errno));
            return -1;
        }
        rcved = DPF_recv(fd, rbuf, sent, 0);
        if (rcved < sent) {
            printf("DPF_recv failed: %s\n", strerror(errno));
            return -1;
        }
        printf("%d bytes received: %s\n", rcved, rbuf);
        for (i=0; i<rcved; i++) {
            if (sbuf[i] != rbuf[i]) {
                printf("compare failed\n");
                return -1;
            }
        }
    }
}
