#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "VSSL.h"

// run as "echo_client_1 server_fqdn port"
int
main(int argc, char *argv[])
{
    int fd;
    struct gen_sockaddr *gaddr;
    char sbuf[1000], rbuf[1000];
    int sent, total, rcved;
    int i;
    unsigned short port;

    if (argc != 3) {
        printf("usage: echo_client_1 server_fqdn port\n");
        return -1;
    }

    vssl_init("client_log", D_FULL, 640000, "client.pem", "root.pem", "password");
    
    while(1) {
        fd = vssl_client(UDP, BLOCK);
        gaddr = vssl_gethostbyname(argv[1]);
        if (gaddr == NULL) {
            printf("vssl_gethostbyname failed: %s\n", strerror(errno));
            return -1;
        }
        port = atoi(argv[2]);
        gaddr->addr.port = htons(port);

        if (vssl_connect(fd, gaddr, BLOCK) < 0) {
            printf("vssl_connect: failed - %s\n", strerror(errno));
            return -1;
        }
        printf("***type string send: ");
        (void) gets(sbuf);
        if (sbuf[0] == '!') {
            vssl_close(fd);
            vssl_fin(0);
            return 0;
        }
        sent = vssl_send(fd, sbuf, strlen(sbuf)+1, 0);
        printf("***%d bytes sent\n", sent);
        total = rcved = 0;
        while(total < sent) {
            rcved = vssl_recv(fd, rbuf, sent - total, 0);
            if (rcved < 0) {
                printf("vssl_recv failed: %s\n", strerror(errno));
                return -1;
            } else if (rcved == 0) {
                printf("server closed\n");
                return 0;
            }
            total += rcved;
        }
        printf("%d bytes received: %s\n", total, rbuf);
        for (i=0; i<total; i++) {
            if (sbuf[i] != rbuf[i]) {
                printf("compare failed\n");
                return -1;
            }
        }
        vssl_close(fd);
    }
}
