#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "DPF.h"
#include "internet.h"

// run as "udp_server_1 port"
int
main(int argc, char *argv[])
{
    if (argc != 2) {
        printf("usage: udp_server_1 port\n");
        return -1;
    }

    int fd = DPF_socket(AF_INET, SOCK_DGRAM, 0);

    short port = atoi(argv[1]);
    uint16_t nport = htons(port);
    struct sockaddr_in myaddr;
    myaddr.sin_family = AF_INET;
    myaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    myaddr.sin_port = nport;
    if (DPF_bind(fd, (struct sockaddr *)&myaddr, sizeof(myaddr)) < 0) {
        printf("DPF_bind failed: %s\n", strerror(errno));
        return -1;
    }

    socklen_t addrlen = sizeof(struct sockaddr_in);
    if (DPF_getsockname(fd, (struct sockaddr *)&myaddr, &addrlen) < 0) {
        printf("DPF_getsockname failed - %s\n", strerror(errno));
        return -1;
    }
    printf("listening on %s\n", _sin2str(&myaddr));

    printf("forking a child process...\n");
    pid_t pid = DPF_fork();
    if (pid == 0) {
        char arg1[10];
        sprintf(arg1, "%d", fd);
        DPF_execl("./udp_echo_server", "udp_echo_server", arg1, NULL);
    } else {
        return 0;
    }
}
