#ifndef __SS_INTERNET_H
#define __SS_INTERNET_H

#include <netinet/in.h>
#include <arpa/inet.h>

#ifdef __cplusplus
extern "C" {
#endif

// fds to str
char * _prtfds(int maxfd, fd_set *fds);
// get a hash value from sin
unsigned short _hash_sin(struct sockaddr_in *addr, unsigned short size);
// string_to_sin
int _str2sin(const char *addr, struct sockaddr_in *sin);
// sin_to_string
char *_sin2str(const struct sockaddr_in *sin);
// sock_to_string
char *_fd2str(int sockd);
// sin_to_hostname
char *_sin2host(const struct sockaddr_in *from, char ***aliases);
// display_from
void _display_from(struct sockaddr_in *from);
// calc_subnet_name
char *_subnet(char* host);
// same_host
int _same_host(const char *h1, const char *h2);
// host_in_domain
int _in_domain( const char *host, const char *domain);
// is_ipaddr
int _valid_ip(const char *inbuf, struct in_addr *sin_addr);
// is_valid_sinful
int _valid_sin(const char *sinful);
// string_to_port
int _str2port(const char* addr);
// string_to_ip
uint32_t _str2ip(const char* addr);
// string_to_ipstr
char *_str2ipstr(const char* addr);
// string_to_hostname
char *_str2host(const char* addr);
// ip_to_name
char *_ip2host(unsigned int ip);
// is_priv_net
int _priv_net(uint32_t ip);
// in_same_net
int _same_net(uint32_t ipA, uint32_t ipB);
// ipport_to_string
char *_ipport2str(const unsigned int ip, const unsigned short port);
// ip_to_string
char *_ip2str(const uint32_t ip);
// getIPaddr
int _myIP(uint32_t *ipaddr);

#ifdef __cplusplus
}
#endif

#endif
