#ifndef __SS_SOCK_H
#define __SS_SOCK_H

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#ifdef __cplusplus
extern "C" {
#endif

int _make_nonblock(int fd);

// Create a nonblocking TCP socket and return fd
int _tcp_nonblock_socket();

// Create a nonblocking UDP socket and return fd
int _udp_nonblock_socket();

int _local_bind(int fd, struct sockaddr_in *my_addr, socklen_t addrlen);

// bind fd to <ipstr:port>
// @args:
//   - fd: file descriptor of a socket
//   - ipstr: dotted notation of ip address like 128.105.175.121.
//            If NULL is passed, the socket will be bound to INADDR_ANY
//   - port: in host byte order
int _inet_bind(int fd, char *ipstr, uint16_t port);

int _tcp_connect(int fd, uint32_t ip, uint16_t port);

// send the content of 'buf' whose size is 'size' bytes
int _tcp_send(int fd, char *buf, size_t size);
#ifdef __cplusplus
}
#endif

#endif
